<template>
    <q-card flat bordered>
        <q-item class="bg-primary text-white">
            <q-item-section avatar>
                <q-avatar v-if="project != null">
                    <img :src="project.principal.logo" :alt="Avatar">
                </q-avatar>
                <q-skeleton type="QAvatar" v-else/>
            </q-item-section>
            <q-item-section v-if="project != null">
                <q-item-label class="text-h6">{{ project.principal.name }}</q-item-label>
                <q-item-label class="text-subtitle1"> {{ project.principal.description }}</q-item-label>
            </q-item-section>
            <q-item-section v-else>
                <q-skeleton type="text"/>
                <q-skeleton type="rect"/>
            </q-item-section>
        </q-item>

        <q-separator/>
        <q-card-section>
            <q-list v-if="project == null" separator>
                <q-item v-for="i in 3" :key="i">
                    <q-skeleton type="text"/>
                </q-item>
            </q-list>
            <q-list v-else>
                <q-item v-for="m in project.member" :key="m.id">
                    <q-item-section>
                        <q-item-label>{{ m.username }}</q-item-label>
                    </q-item-section>

                    <q-item-section side top v-if="m.id === project.owner.id">
                        <q-item-label caption> Owner</q-item-label>
                    </q-item-section>
                    <q-item-section top side v-else>
                        <div class="text-grey-8 q-gutter-xs">
                            <RemoveUserFromProjectDialog :user="m" @delete="$emit('delete')"/>
                        </div>
                    </q-item-section>
                </q-item>
            </q-list>
        </q-card-section>
        <q-separator/>
        <q-card-actions align="around">
            <AddUserToProjectDialog v-if="project != null" :project="project" @submit="$emit('submit')"/>
            <q-skeleton v-else type="QBtn"/>
            <q-btn v-if="project != null" outline label="Change Project" icon="shuffle" color="primary" to="/project"/>
            <q-skeleton v-else type="QBtn"/>

        </q-card-actions>
    </q-card>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {ProjectResponse} from "src/classLibrary/APIModels/core/projectResponse";
import AddUserToProjectDialog from "components/Dialog/AddUserToProjectDialog.vue";
import RemoveUserFromProjectDialog from "components/Dialog/RemoveUserFromProjectDialog.vue";
import {GenerateAvatar} from "src/classLibrary/AvatarGenerator";

@Component({
    components: {RemoveUserFromProjectDialog, AddUserToProjectDialog}
})
export default class ProjectFullCard extends Vue {
    @Prop() project!: ProjectResponse

    get Avatar(): string {
        return GenerateAvatar(this.project.principal.name);
    }
}
</script>

<style lang='scss' scoped>

</style>
